       subroutine aua(j)
C-------------------------------------------------------------------------------
C  @(#)aua.F	5.1 06/22/94
C-------------------------------------------------------------------------------
c
c      aua - FV, FF, VC, CV, FC, CF, CC, FF, VV, Line, Histogram, Points, Rline,
c             Rhist, Rpoints, Freey, Holdy, Range, Spread, Saxis
c
C-------------------------------------------------------------------------------
c
      integer*2 j, iptwh, jj, ierr, i1, i2
      integer*2 m1, m2, m3, n0, n112, n120, n245, n272
      real*4 zmin, zmax, v1, v2, ch1, ch2, z1, z2
      real*8 xtochan
      logical okarray, okreal4, okreal8
c
      include 'cform.inc'
      include 'appl.inc'
      include 'core.inc'
      include 'stk.inc'
c
      data m1, m2, m3, n0, n112, n120, n272, n245
     .     /-1, -2, -3, 0, 112, 120, 272, 245/
c
      iptwh = 1
c
      JJ=J
      GO TO (130,131,140,141,142,143,144,145,146,160,170,180,190,200,
     .       210,149,150,220,270,280), JJ
      call oerror(n120, m3, 'AUA')
C-------------------------------------------------------------------------
C                                      FV   
C-----------------------------------------------------------------------
  130 CONTINUE
      LXA=2
      UXA=3
      GO TO 99
C-------------------------------------------------------------------------
C                                      VF  
C-----------------------------------------------------------------------
  131 CONTINUE
      LXA=3
      UXA=2
      GO TO 99
C-----------------------------------------------------------------------
C                                     VC 
C-----------------------------------------------------------------------
  140 CONTINUE
      LXA=3
      UXA=1
      GO TO 99
C-----------------------------------------------------------------------
C                                     CV 
C-----------------------------------------------------------------------
  141 CONTINUE
      LXA=1
      UXA=3
      GO TO 99
C-----------------------------------------------------------------------
C                                     FC
C-----------------------------------------------------------------------
  142 CONTINUE
      LXA=2
      UXA=1
      GO TO 99
C-----------------------------------------------------------------------
C                                     CF
C-----------------------------------------------------------------------
  143 CONTINUE
      LXA=1
      UXA=2
      GO TO 99
C-----------------------------------------------------------------------
C                                     CC  
C-----------------------------------------------------------------------
  144 CONTINUE
      LXA=1
      UXA=1
      GO TO 99
C-----------------------------------------------------------------------
C                                     FF 
C-----------------------------------------------------------------------
  145 CONTINUE
      LXA=2
      UXA=2
      GO TO 99
C-----------------------------------------------------------------------
C                                     VV 
C-----------------------------------------------------------------------
  146 CONTINUE
      LXA=3
      UXA=3
      GO TO 99
C---------------------------------------------------------------------
C                                     LINE
C---------------------------------------------------------------------
  160 CONTINUE
      SPLT=0
      GO TO 99
C---------------------------------------------------------------------
C                                     HISTOGRAM
C---------------------------------------------------------------------
  170 CONTINUE
      SPLT=1
      GO TO 99
C---------------------------------------------------------------------
C                                     POINTS
C---------------------------------------------------------------------
  180 CONTINUE
      SPLT=2
      GO TO 99
C----------------------------------------------------------------------
C                                RLINE
C----------------------------------------------------------------------
  190 CONTINUE
      RPLT=0
      GO TO 99
C-----------------------------------------------------------------------
C                                RHIST
C-----------------------------------------------------------------------
  200 CONTINUE
      RPLT=1
      GO TO 99
C-----------------------------------------------------------------------
C                                RPOINTS
C-----------------------------------------------------------------------
  210 CONTINUE
      RPLT=2
      GO TO 99
C---------------------------------------------------------------------
C					FREEY
C---------------------------------------------------------------------
 149  YLMIN=-9.0E4
      GO TO 99
C---------------------------------------------------------------------
C					HOLDY
C---------------------------------------------------------------------
 150  YLMIN=-9.0E10
      GO TO 99
C-------------------------------------------------------------------
C                             YRANGE    
C-----------------------------------------------------------------
  220 CONTINUE
      IF (SP.lt.2) call oerror(n112, m1, 'YRANGE')
c
      z1=V(SP)
      SP=SP-1
      z2=V(SP)
      SP=SP-1

      if (.not. okreal4(z1) .or. .not. okreal4(z2) ) 
     .		call oerror(n112, m1, 'YRANGE')
c
      zmin=min(z1,z2)
      zmax=max(z1,z2)
c
      if (zmin.ge.zmax) call oerror(n112, m2, 'YRANGE')
c
      YLMIN=ZMIN
      YLINCR=(ZMAX-ZMIN)/5.0
      GO TO 99
C---------------------------------------------------------------------
C							  XRANGE
C---------------------------------------------------------------------
 270  CONTINUE
c
      IF (SP.lt.2) call oerror(n112, m1, 'XRANGE')
c
      V2=V(SP)
      SP=SP-1
      V1=V(SP)
      SP=SP-1
c
      if (.not. okarray(lxa, dtwh(1,iptwh)) )
     .			call oerror(n272, m2, 'XRANGE')
c
      if (.not. okreal4(v1) .and. .not. okreal4(v2) ) then
	v1 = DTWH(C12SPN,IPTWH) - 1
	v2 = DTWH(C12SPN,IPTWH)+DTWH(C12NI,IPTWH)
      else if (.not. okreal4(v1) ) then 
	v1 = DTWH(C12SPN,IPTWH) - 1
        v2 = xtochan(lxa, dtwh(1,iptwh), v2, ierr)
      else if (.not. okreal4(v2) ) then 
        v1 = xtochan(lxa, dtwh(1,iptwh), v1, ierr)
	v2 = DTWH(C12SPN,IPTWH)+DTWH(C12NI,IPTWH)
      else
        ch1 = xtochan(lxa, dtwh(1,iptwh), v1, ierr)
        ch2 = xtochan(lxa, dtwh(1,iptwh), v2, ierr)
        v1 = min(ch1, ch2)
        v2 = max(ch1, ch2)
      endif
c
      BDROP = v1 - DTWH(C12SPN,IPTWH)
      EDROP = DTWH(C12SPN,IPTWH)+DTWH(C12NI,IPTWH) - 1 - v2
c
      if(edrop.lt.0) then
	edrop = 0
	call oerror(n245, n0, 'XRANGE: Setting EDROP to zero')
      endif
      if(bdrop.lt.0) then
	bdrop = 0.
	call oerror(n245, n0, 'XRANGE: Setting BDROP to zero')
      endif
      if(bdrop+edrop.ge.dtwh(c12ni,iptwh)) then	
	bdrop=0.
	edrop=0.
	call oerror(n245, n0, 'XRANGE: Setting BDROP and EDROP to zero')
      endif
c
      GO TO 99
C---------------------------------------------------------------------
C							  SAXIS
C---------------------------------------------------------------------
 280  CONTINUE
c
      IF (SP.lt.2) call oerror(n112, m1, 'SAXIS')
c
      if (.not. okreal8(v(sp)) ) v(sp) = 3
      if (.not. okreal8(v(sp-1)) ) v(sp-1) = 2
c
      i2=nint(V(SP))
      SP=SP-1
      i1=nint(V(SP))
      SP=SP-1
c
      if (i1 .lt. 1 .or. i1 .gt. 11) call oerror(n112, m1, 'SAXIS')
      if (i2 .lt. 1 .or. i2 .gt. 11) call oerror(n112, m1, 'SAXIS')
c
      lxa = i1
      uxa = i2
c
      goto 99
c
C --------------------------------------------------------------
99    return
      end
